/*
 * An eXtreme Programming Episode
 * by Robert Martin and Robert Ross
 */

package bowlingxp.v3;

public class Scorer {
    
    private int palla;
    private int[] tiri = new int[21];
    private int tiroCorrente = 0;
    
    public void addTiro(int birilli) {
        tiri[tiroCorrente] = birilli;
        tiroCorrente++;
    }
    
    public int getPunteggioFrame(int numeroFrame) {
        palla = 0;
        int punteggio=0;
        for (int i = 0; i < numeroFrame; i++) {
            if (strike()) {
                punteggio += 10 + prossimeDuePalle();
            } else if (spare()) {
                punteggio += 10 + prossimaPalla();
            } else {
                punteggio += birilliFrame();
            }
        }
        return punteggio;
    }
    
    private boolean strike() {
        if (tiri[palla] == 10) {
            palla++;
            return true;
        }
        return false;
    }
    
    private boolean spare() {
        if ((tiri[palla] + tiri[palla + 1]) == 10) {
            palla += 2;
            return true;
        }
        return false;
    }
    
    private int prossimeDuePalle() {
        return tiri[palla] + tiri[palla+1];
    }
    
    private int prossimaPalla() {
        return tiri[palla];
    }
    
    private int birilliFrame() {
        int birilli = tiri[palla] + tiri[palla + 1];
        palla += 2;
        return birilli;
    }
}
